//
//  Villo.m
//  villo
//
//  Created by Philip Bernstein on 4/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//
/*
 NOTES TO SELF:
 
 - Stop it with the continous parameter allocation. Its seriously the same 99% of the time. Just make an authenticatedParameters object (or even, CLASS?!ZOMG) and modify it from there.
 
 - Gifts. Dont know what the fuck is going on with those. Ask Jordan when he's not being a pissy bitch.
 
 */
#import "Villo.h"

@implementation Villo
@synthesize ChatDelegate, username, apiKey, appId, RequestDelegate, token;
-(id)initWithOptions:(NSMutableDictionary *)options chat:(BOOL)chat
{
    self = [super init];
    
    if (self)
    {
        if (chat)
        {
            isAuthenticated = false;
            if ([[NSUserDefaults standardUserDefaults] objectForKey:@"username"])
                isAuthenticated = true;
            
            pubnub = [[CEPubnub alloc] initWithPublishKey:@"pub-42c6b905-6d4e-4896-b74f-c1065ab0dc10" subscribeKey:@"sub-4e37d063-edfa-11df-8f1a-517217f921a4"  secretKey:@"sec-6cdc9cd5-b1d2-4d5a-bf35-c93e7a2d3237" sslOn:NO origin:@"pubsub.pubnub.com"];
            self.apiKey = [options objectForKey:@"api"];
            self.appId = [options objectForKey:@"appid"];
        }
    }
    
    return self;
}
-(BOOL)isSubscribed:(NSString *)room
{
    if (pubnub)
        return [pubnub subscribed:room];
    else
        return FALSE;
}
-(void)publish:(NSString *)message room:(NSString *)room extra:(NSDictionary *)extra
{
    if (!pubnub || !isAuthenticated)
        return;
    
    NSMutableDictionary *package = [[NSMutableDictionary alloc] init];
    [package setObject:message forKey:@"message"];
    [package setObject:self.username forKey:@"username"];
    if (extra)
        [package setObject:extra forKey:@"extra"];
    [pubnub publish:room message:package delegate:self];
    
}
-(void)subscribe:(NSString *)room
{
    if (pubnub && isAuthenticated)
        [pubnub subscribe:room delegate:self];
}
- (void)pubnub:(CEPubnub *)pubnub subscriptionDidReceiveDictionary:(NSDictionary *)response onChannel:(NSString *)channel
{
    NSLog(@"%@", response);
    if (self.ChatDelegate && [self.ChatDelegate respondsToSelector:@selector(messageReceived:username:room:extra:)])
    {
        [self.ChatDelegate messageReceived:[response objectForKey:@"message"] username:[response objectForKey:@"username"] room:channel extra:[response objectForKey:@"extra"]];
    }
}
-(void)login:(NSString *)user password:(NSString *)password
{
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
    [parameters setObject:self.apiKey forKey:@"api"];
    [parameters setObject:self.appId forKey:@"appid"];
    [parameters setObject:user forKey:@"username"];
    [parameters setObject:password forKey:@"password"];
    loginRequest = [[VilloRequest alloc] initWithURL:@"https://api.villo.me/user/login.php" method:@"POST" parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
        NSString *response = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"LOGGED IN: %@", response);
        bool login = false;
        response = [response stringByReplacingOccurrencesOfString:@" " withString:@""];
        if (![response isEqualToString:@"1"] && ![response isEqualToString:@"2"])
        {
            login = true;
            [[NSUserDefaults standardUserDefaults] setObject:user forKey:@"username"];
            [[NSUserDefaults standardUserDefaults] setObject:response forKey:@"token"];
            [[NSUserDefaults standardUserDefaults] synchronize];
            self.username = user;
            self.token = response;
            isAuthenticated = TRUE;
            
        }
        if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(loginCompletedWithResponse:)])
            [self.RequestDelegate loginCompletedWithResponse:login];
        
    }];
}
-(void)addFriend:(NSString *)user
{
    if (isAuthenticated)
    {
        NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
        [parameters setObject:self.username forKey:@"username"];
        [parameters setObject:self.token forKey:@"token"];
        [parameters setObject:@"add" forKey:@"type"];
        [parameters setObject:self.appId forKey:@"appid"];
        [parameters setObject:self.apiKey forKey:@"api"];
        [parameters setObject:user forKey:@"addUsername"];
        friendRequest = [[VilloRequest alloc] initWithURL:@"https://api.villo.me/friends.php" method:@"POST" parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
            
            NSString *response = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
            NSLog(@"FRIEND ADDED: %@", response);
            bool success = false;
            if ([response rangeOfString:@"\"friends\":"].location != NSNotFound) // my lazy way of checking.
                success = true;
            if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(friendAddedWithResponse:username:)])
                [self.RequestDelegate friendAddedWithResponse:success username:user];
            
        }];
     
    }
}
-(void)getFriends
{
    if (isAuthenticated)
    {
        NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
        [parameters setObject:self.username forKey:@"username"];
        [parameters setObject:self.token forKey:@"token"];
        [parameters setObject:@"get" forKey:@"type"];
        [parameters setObject:self.appId forKey:@"appid"];
        [parameters setObject:self.apiKey forKey:@"api"];
        friendRequest = [[VilloRequest alloc] initWithURL:@"https://api.villo.me/friends.php" method:@"POST" parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
            if (error || !data)
            {
                if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(friendsReceivedWithResponse:error:)])
                {
                    [self.RequestDelegate friendsReceivedWithResponse:NULL error:TRUE];
                }
                return;
            }
            NSError *jsonError;
            id object = [NSJSONSerialization JSONObjectWithData:data options:0 error:&jsonError];
            if (!error && object)
            {
                if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(friendsReceivedWithResponse:error:)])
                {
                    [self.RequestDelegate friendsReceivedWithResponse:[[NSMutableDictionary alloc] initWithDictionary:object]  error:false];
                }
            }
            else 
            {
                [self.RequestDelegate friendsReceivedWithResponse:NULL error:TRUE];

            }
            
        }];
        
    }

}
-(void)removeFriend:(NSString *)user
{
    if (isAuthenticated)
    {
        NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
        [parameters setObject:self.username forKey:@"username"];
        [parameters setObject:self.token forKey:@"token"];
        [parameters setObject:@"remove" forKey:@"type"];
        [parameters setObject:self.appId forKey:@"appid"];
        [parameters setObject:self.apiKey forKey:@"api"];
        [parameters setObject:user forKey:@"removeUsername"];
        friendRequest = [[VilloRequest alloc] initWithURL:@"https://api.villo.me/friends.php" method:@"POST" parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
            
            NSString *response = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
            NSLog(@"FRIEND REMOVED: %@", response);
            bool success = false;
            if ([response rangeOfString:@"\"friends\":"].location != NSNotFound) // my lazy way of checking.
                success = true;
            if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(friendRemovedWithResponse:username:)])
                [self.RequestDelegate friendRemovedWithResponse:success username:user];
            
        }];
        
    }

}
-(void)sendRequestToURL:(NSString *)urlString method:(NSString *)method parameters:(NSMutableDictionary *)parameters callback:(VilloCompletionHandler)handler;
{
    if (isAuthenticated)
    {
    [parameters setObject:self.apiKey forKey:@"api"];
    [parameters setObject:self.appId forKey:@"appid"];
    [parameters setObject:self.username forKey:@"username"];
    [parameters setObject:self.token forKey:@"token"];
    
    friendRequest = [[VilloRequest alloc] initWithURL:urlString method:method parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
        
        handler(connection, error, urlString, data);
        
    }];
    }
    
}
-(void)getLeaders:(NSString *)duration board:(NSString *)board limit:(int)limit
{
    if (isAuthenticated)
    {
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc] init];
    [parameters setObject:duration forKey:@"type"];
    [parameters setObject:[NSString stringWithFormat:@"%d", limit] forKey:@"limit"];
    [parameters setObject:self.apiKey forKey:@"api"];
    [parameters setObject:self.appId forKey:@"appid"];
    [parameters setObject:self.username forKey:@"username"];
        [parameters setObject:board forKey:@"appName"];
    leaderRequest = [[VilloRequest alloc] initWithURL:@"https://api.villo.me/leaders.php" method:@"POST" parameters:parameters completionHandler:^(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data) {
        NSLog(@"REZ: %@", [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]);
        NSError *jsonError;
        id object = [NSJSONSerialization JSONObjectWithData:data options:0 error:&error];
        if (!object || jsonError)
        {
            if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(leadersReceivedWithResponse:error:)])
            {
                [self.RequestDelegate leadersReceivedWithResponse:NULL error:TRUE];
            }
            return;
        }
        NSMutableDictionary *dictionary = [NSMutableDictionary dictionaryWithDictionary:object];
        NSLog(@"LEADERS: %@", dictionary);
        if (self.RequestDelegate && [self.RequestDelegate respondsToSelector:@selector(leadersReceivedWithResponse:error:)])
        [self.RequestDelegate leadersReceivedWithResponse:dictionary error:NO];
        
    }];
        
    }
}

@end
