//
//  VilloRequest.h
//  villo
//
//  Created by Philip Bernstein on 4/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
@class VilloRequest;

typedef void (^VilloRequestCompletionHandler)(VilloRequest *connection, NSError *error, NSString *urlString, NSData *data);

@interface VilloRequest : NSObject <NSURLConnectionDelegate>
{
    
}
-(id)initWithURL:(NSString *)URL method:(NSString *)method parameters:(NSDictionary *)parameters completionHandler:(VilloRequestCompletionHandler)handler;
-(void)cancel; // only used to cancel request midway. Cant see myself using this.
@property (nonatomic, retain) NSString *urlString;
@property (nonatomic, retain) NSMutableData *connectionData;
@property (nonatomic, retain) NSMutableURLRequest *request;
@property (nonatomic, retain) NSURLConnection *connection;
@property (nonatomic, copy, readonly) VilloRequestCompletionHandler completionHandler;

@end
